SystemOrganization addCategory: #'DAO-TP-Changes'!

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:06'!
cambio01
	^1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:42'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:02'!
classCategoryAdded: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryAdded) value: (CategoryAdded categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:16'!
classRemoved: aClass fromCategory: aCategoryName
	( diccionarioDeAcciones at: ClassRemoved ) value: (ClassRemoved class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:06'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:37'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:10'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:41'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:08'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo registrarCambio: self cambio01.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self cambio01 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/28/2013 20:41'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/28/2013 20:41'!
test006ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unSistemaDeCambios registrarCambio: self cambio01.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 
	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/28/2013 20:40'!
test007ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/28/2013 20:40'!
test008ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/29/2013 18:18'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios unaInterfaceDeEventosDeEntrada unEvento |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios new.

	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	unaInterfaceDeEventosDeEntrada := InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.
	unEvento := (ClassCreated newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes').
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1.

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/29/2013 18:24'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios unaInterfaceDeEventosDeEntrada unEvento |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unaInterfaceDeEventosDeEntrada := InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.
	unEvento := ClassCreated newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = 'Seba') 
																								and: unRegistroDeCambio fechaYHora = unReloj now) 
																								and: unRegistroDeCambio cambio nombreDeClase = 'ChangesTest')
																								and:  unRegistroDeCambio cambio nombreDeCategoria = 'DAO-TP-Changes'] ).
	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/29/2013 18:29'!
test012ElSistemaRegistraLosCambiosDeTipoClassRemoved
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unSistemaDeAnuncios classRemoved: ChangesTest fromCategory: #'DAO-TP-Changes'.
	 
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios todosLosCambios size = 1.
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unCambio | ((unCambio autor = 'Seba') and: unCambio fechaYHora = unReloj now) and: unCambio tipoDeCambio = 'classRemoved' ] ).
	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/29/2013 12:48'!
test013ElSistemaRegistraLosCambiosDeTipoClassCategoryCreated
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unSistemaDeAnuncios classCategoryAdded: #'DAO-TP-Changes'.
	 
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios todosLosCambios size = 1.
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unCambio | (((unCambio autor = 'Seba') 
																						and: unCambio fechaYHora = unReloj now) 
																						and: unCambio tipoDeCambio = 'classCategoryCreated') 
																						and: unCambio categoriaAgregada = 'DAO-TP-Changes' ] ).
	! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'Maxii 9/29/2013 18:08'!
test100LaInterfaceDeEventosDeEntradaRegistraLosEventosDeTipoClassCreated
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios unaInterfaceDeEventosDeEntrada unEvento |
	
	unReloj := self relojTest.
	unAutor := self autorTest.
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios new.
	
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unaInterfaceDeEventosDeEntrada := InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.
	unEvento := (ClassCreated newWithThisName: 'ChangesTest' andThisCategoty: 'DAO-TP-Changes').
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert:	(unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | ((unRegistroDeCambio autor = 'Seba' 
																					and: unRegistroDeCambio fechaYHora = unReloj now) 
																					and: unRegistroDeCambio cambio nombreDeClase = 'ChangesTest') 
																					and: unRegistroDeCambio cambio nombreDeCategoria = 'DAO-TP-Changes' ] )! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:11'!
tipoDelCambio01
	^'Agregar'.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:11'!
unSystemAnnouncer
	^self.! !

Object subclass: #Cambio
	instanceVariableNames: 'nombreDeCategoria nombreDeClase autor fechaYHora tipoDeCambio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Cambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:25'!
newWithThisUserName: unNombreDeUsuario atThisTime: unaHora withThisEvent: unEvento
	( unEvento isKindOf: ClassAdded ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unEvento classAdded name enLaCategoria: unEvento classCategory ].
	( unEvento isKindOf: ClassRemoved ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora borro: unEvento classRemoved name enLaCategoria: unEvento categoryName ].
	( unEvento isKindOf: CategoryAdded ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creoLaCategoria: unEvento categoryName ].
	( unEvento = 'classAdded' ) ifTrue: [ ^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unEvento enLaCategoria: unEvento ]! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:09'!
autor
	^autor.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:13'!
categoriaAgregada
	^nombreDeCategoria.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:48'!
esteTipo: unNombreDeUsuario aEstaHora: unaHora borro: unNombreDeClase enLaCategoria: unaCategoria 
	autor := unNombreDeUsuario.
	fechaYHora := unaHora.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unaCategoria.
	tipoDeCambio := 'classRemoved'.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:49'!
esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unNombreDeClase enLaCategoria: unaCategoria
	autor := unNombreDeUsuario.
	fechaYHora := unaHora.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unaCategoria.
	tipoDeCambio := 'classAdded'.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:13'!
esteTipo: unNombreDeUsuario aEstaHora: unaHora creoLaCategoria: unNombreDeCategoria 
	autor := unNombreDeUsuario.
	fechaYHora := unaHora.
	nombreDeCategoria := unNombreDeCategoria.
	tipoDeCambio := 'classCategoryCreated'.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:59'!
fechaYHora
	^fechaYHora.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:20'!
initializeWithThisCategory: unNombreDeCategoria andThisClass: unNombreDeClase 
	nombreDeCategoria := unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:24'!
initializeWithThisCategoryName: unNombreDeCategoria andThisClassName: unNombreDeClase 
	nombreDeCategoria := unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:18'!
nombreDeCategoria
	^nombreDeCategoria.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:19'!
nombreDeClase
	^nombreDeClase.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:42'!
tipoDeCambio
	^tipoDeCambio.! !

Object subclass: #CambioClaseAgregada
	instanceVariableNames: 'nombreDeClase nombreDeLaCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!CambioClaseAgregada class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:48'!
newWithThisClassName: unNombreDeClase inThisCategory: unNombreDeCategoria 
	^self new initializeWithThisClassName: unNombreDeClase  andThisCategory: unNombreDeCategoria.! !

!CambioClaseAgregada class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:51'!
newWithThisClassName: nombreDeClase inThisCategory: nombreDeCategoria by: nombreDelAutor at: unaFechaYHora
	^self new initializeWithThisClassName: nombreDeClase inThisCategory: nombreDeCategoria by: nombreDelAutor at: unaFechaYHora.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:43'!
autor
	^nombreDelAutor.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:43'!
fechaYHora
	^ fechaYHora! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:49'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria 
	nombreDeClase := unNombreDeClase.
	nombreDeLaCategoria := unNombreDeCategoria.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:53'!
initializeWithThisClassName: unNombreDeClase inThisCategory: unNombreDeCategoria by: unNombreDelAutor at: unaFechaYHora
	nombreDeClase := unNombreDeClase.
	nombreDeLaCategoria := unNombreDeCategoria.
	nombreDelAutor := unNombreDelAutor.
	fechaYHora := unaFechaYHora.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:10'!
nombreDeCategoria
	^nombreDeLaCategoria.! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:10'!
nombreDeClase
	^ nombreDeClase! !

!CambioClaseAgregada methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:43'!
tipoDeCambio
	^'classAdded'! !

Object subclass: #ClassCreated
	instanceVariableNames: 'nombreDeClase nombreDeCategoria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ClassCreated class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:45'!
newWithThisName: unNombreDeClase andThisCategoty: unNombreDeCategoria 
	^self new initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.! !

!ClassCreated methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:30'!
initializeWithThisClassName: unNombreDeClase andThisCategory: unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unNombreDeCategoria.! !

!ClassCreated methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:45'!
nombreDeLaCategoria
	^nombreDeCategoria.! !

!ClassCreated methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:45'!
nombreDeLaClase
	^nombreDeClase.! !

Object subclass: #InterfaceDeEntradaDelSistemaDeCambios
	instanceVariableNames: 'sistemaDeCambios autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfaceDeEntradaDelSistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj 
	^self new initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:52'!
agregarCambio: unCambio por: unNombreDeAutor enElMomento: unaFechaYHora 

	sistemaDeCambios registrarCambio: (RegistroDeCambio newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:43'!
handle: unEventoDeLainterface 
	self agregarCambio: (CambioClaseAgregada newWithThisClassName: unEventoDeLainterface nombreDeLaClase inThisCategory: unEventoDeLainterface nombreDeLaCategoria ) por: autor fullName enElMomento: reloj now ! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj
	sistemaDeCambios := unSistemaDeCambios.
	autor := unAutor.
	reloj := unReloj.! !

Object subclass: #RegistroDeCambio
	instanceVariableNames: 'cambio autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!RegistroDeCambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:54'!
newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	^self new initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
autor
	^ autor! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:04'!
cambio
	^ cambio! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
fechaYHora
	^ fechaYHora! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:58'!
initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	cambio := unCambio.
	autor := unNombreDeAutor.
	fechaYHora := unaFechaYHora.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva systemAnnouncer autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 21:11'!
newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	^self new initializeWith: unSistemaDeAnuncios andThisAuthor: unAutor andThisClock: unReloj.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/24/2013 21:53'!
cerrarUnidadDeTrabajoActiva
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 23:01'!
handle: unEvento
	self registrarCambio: (Cambio newWithThisUserName: autor fullName atThisTime: reloj now withThisEvent: unEvento ).
	"self unidadActiva registrarCambio: (Cambio for: unEvento) ."! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:34'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:14'!
initializeWith: unSistemaDeAnuncios andThisAuthor: unAutor andThisClock: unReloj.
	systemAnnouncer := unSistemaDeAnuncios.
	autor := unAutor.
	reloj := unReloj.
"	systemAnnouncer on: ClassAdded do: [ :unEvento |  self handle: unEvento ].
	systemAnnouncer on: ClassRemoved do: [ :unEvento |  self handle: unEvento ].
	systemAnnouncer on: CategoryAdded do: [ :unEvento |  self handle: unEvento ]."
	^self.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 21:12'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadesDeTrabajoCerradas  add: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
todosLosCambios
	^cambios.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!
